###################################################
### chunk number 1: 
###################################################
options(width = 80)
library("kst")


###################################################
### chunk number 2: kstructure
###################################################
# An endorelation representing a surmise relation
kst <- endorelation(graph=set(tuple(1,1), tuple(2,2), tuple(3,3),
  tuple(4,4), tuple(2,1), tuple(3,1), tuple(4,1), tuple(3,2), tuple(4,2)))
kstructure(kst)
# A set of sets representing knowledge states (e.g., clauses of a surmise system)
kst <- kstructure(set(set("a"), set("a","b"), set("a","c"), set("d","e"), 
   set("a","b","d","e"), set("a","c","d","e"), set("a","b","c","d","e")))
kst


###################################################
### chunk number 3: set_options
###################################################
sets_options("quote",FALSE)
kst


###################################################
### chunk number 4: kdomain
###################################################
kdomain(kst)


###################################################
### chunk number 5: katoms
###################################################
katoms(kst, items=set("a","b","c"))


###################################################
### chunk number 6: knotions
###################################################
knotions(kst)


###################################################
### chunk number 7: ktrace
###################################################
ktrace(kst, items=set("c","d","e"))


###################################################
### chunk number 8: plot
###################################################
plot(kst)


###################################################
### chunk number 9: 
###################################################
plot(kst)


###################################################
### chunk number 10: as.relation
###################################################
as.relation(kst)


###################################################
### chunk number 11: kassess
###################################################
rp <- data.frame(a=c(1,1,0,1,1,1,1,0,0,0),b=c(0,1,0,1,0,1,0,1,0,0),
   c=c(0,0,0,0,1,1,1,0,1,0),d=c(0,0,1,1,1,1,0,0,0,1), e=c(0,0,1,1,1,1,0,0,0,0))
kassess(kst, rpatterns=rp)


###################################################
### chunk number 12: kvalidate
###################################################
kvalidate(kst, rpatterns=rp, method="gamma")
kvalidate(kst, rpatterns=rp, method="percent")
kvalidate(kst, rpatterns=rp, method="VC")
kvalidate(kst, rpatterns=rp, method="DA")


###################################################
### chunk number 13: closure
###################################################
closure(kst, operation="union")


###################################################
### chunk number 14: reduction
###################################################
reduction(kst, operation="discrimination")


###################################################
### chunk number 15: kspace
###################################################
ksp <- kspace(kst)
ksp


###################################################
### chunk number 16: kstructure_is_space
###################################################
kstructure_is_kspace(ksp)


###################################################
### chunk number 17: kbase
###################################################
kbase(ksp)


